﻿//================================================
/*

 gPod Controller - Control your iTunes with your gPod.
 Copyright (c) 2007 Glenn Rivkees.
 http://glennrivkees.com/gadgets/

    This file is part of gPod Controller.

    gPod Controller is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    gPod Controller is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with gPod Controller; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    To view a copy of this license, visit http://creativecommons.org/licenses/GPL/2.0/

*/
//================================================

/*GlobalVar*/
var helpdivison;

function view_onOpen() {
options.putDefaultValue("OP_OTHER_INFO_OPT", "Genre")  
options.putDefaultValue("OP_OFF_OPT", 1)//0=no quit, 1=quit
options.putDefaultValue("OP_VOL_OPT", 1)//0=disabled,1=enabled
options.putDefaultValue("OP_COL_OPT", 1)//1=bla,2=blu,3=gre,4=pin,5=red,6=sil
options.putDefaultValue("OP_COL_OPT_3G", 1)//1=bla,2=blu,3=gre,4=red,5=sil
options.putDefaultValue("OP_COL_OPT_SHUFF", 1)//1=sil,2=blu,3=gre,4=red,5=pur
options.putDefaultValue("OP_SHOW_DOCKED_OPT", 2)//1=nano2G, 2=shuffle, 3=nano3G
options.putDefaultValue("OP_SHOW_UNDOCKED_OPT", 3) //1=nano, 2=shuffle, 3=nano3G
options.putDefaultValue("OP_SHOW_ON_OPEN_HELP_OPT", true)
//changebgcolor();
pluginHelper.onAddCustomMenuItems = onAddCustomMenuItems;
onOpenStateStuff();
onopensetbg();
checkupdate();
helpdivison=true;
showonopenhelp();
}

/*Set Global Vars*/
var iTunesIsOn=0;
var iTunesApp;
var displaymode=0;
var updatedisplayint;

/*Button Functions*/
function menubuttonpress(){
debug.trace("menu but press");
pluginHelper.showOptionsDialog();
if (iTunesIsOn==1){
}
}
function playpausebuttonpress(){
if (iTunesIsOn==1){
try{
iTunesApp.PlayPause();
}
catch(error){
}

}
}

function prevbuttonpress(){
if (iTunesIsOn==1){
try{
iTunesApp.BackTrack()
}
catch(error){
}

}
}

function nextbuttonpress(){
if (iTunesIsOn==1){
try{
iTunesApp.NextTrack()
}
catch(error){
}

}
}

function selectbuttonpress(){
if (iTunesIsOn==1){
displaymode++;
//if rollover back to 1
if (displaymode==5){
displaymode=1;
}

//set display mode screen
if (displaymode==1){
displaydiv1.visible=true;
displaydiv2.visible=false;
displaydiv3.visible=false;
displaydiv4.visible=false;
hide_volume();
}
else if (displaymode==2){
displaydiv1.visible=false;
displaydiv2.visible=true;
displaydiv3.visible=false;
displaydiv4.visible=false;
hide_volume();
}
else if (displaymode==3){
displaydiv1.visible=false;
displaydiv2.visible=false;
displaydiv3.visible=true;
displaydiv4.visible=false;
hide_volume();
}
else if (displaymode==4){
displaydiv1.visible=false;
displaydiv2.visible=false;
displaydiv3.visible=false;
displaydiv4.visible=true;
hide_volume();
}

}
}


/*Display Modes*/
//1=track progress view(volume set)
//2=track progress set
//3=artwork view
//4=stars


/*On/Off Timer*/
function onoffbutttimer(start_stop){
//var on_off_timout;
if (start_stop=="start"){
on_off_timout = setTimeout("iTunesOnOff();",2000);
}
else if (start_stop=="stop"){
clearTimeout(on_off_timout);
}
else{debug.error("Error1");}
}


/*On/Off*/
function iTunesOnOff(){
if (iTunesIsOn==0){
try{
//loadingimg.visible=true;
iTunesApp = new ActiveXObject("iTunes.Application");
//loadingimg.visible=false;
screenoffdisplay.visible=0;
helpdiv.visible=0;
screenoffdisplay3G.visible=0;
helpdivnano3G.visible=0;
iTunesIsOn=1;
displaymode=1;
displaymode3G=1;
shuffleonoffbut.x=95;
//iTunesApp.Play();
updatescreen();
updatedisplayint=setInterval("updatescreen()", 1000);
}
catch(error){
debug.error("ITUNES ON ERROR"+error);

clearInterval(updatedisplayint);
screenoffdisplay.visible=1;
screenoffdisplay3G.visible=1;
shuffleonoffbut.x=85;
iTunesIsOn=0;
showonopenhelp();
displaymode=0;
displaymode3G=0;

wanttodownloaditunes = confirm('An error occurred while attempting to open iTunes. \nMake sure iTunes is installed. \n\nDo you want to open the iTunes download website?');
	if(wanttodownloaditunes==true){
	var winShell = new ActiveXObject("Shell.Application");
	winShell.ShellExecute("http://www.apple.com/itunes/download/"); 
	}
}
}
else if (iTunesIsOn==1){
try{
if(options.getValue("OP_OFF_OPT")==1){iTunesApp.Quit();}
}
catch(error){
}
clearInterval(updatedisplayint);
screenoffdisplay.visible=1;
screenoffdisplay3G.visible=1;
shuffleonoffbut.x=85;
iTunesIsOn=0;
showonopenhelp();
displaymode=0;
displaymode3G=0;
}
else{alert("Error2");}
}

/*Update All*/
function updatescreen(){

if(iTunesIsOn){
try{
//if itunes is on the try will work
itunesisrealyontestvariable = iTunesApp.Version;
}
catch(e){
//if itunes is on, catch
//debug.error(e);
iTunesOnOff();
}
}

//debug.trace(isMinimized);
//if not minimized
if(isMinimized!=true){

//if showing nano 2G
if(UI2show==1){
debug.trace("Update Screen 2G MAX");
updatepower();
updatesonginfo();
updatetrackprogress();
updatetrackselectposprogress();
updatestars();
updateplay_pause();
}
//if showing shuffle
else if(UI2show==2){
//shuffle update stuff
}
//if showing nano3G
else if(UI2show==3){
debug.trace("Update Screen 3G MAX");
updatepower3G();
updatesonginfo3G();
updatetrackprogress3G();
updatetrackselectposprogress3G();
updatestars3G();
updateplay_pause3G();
}

}
//if minimized
else if(isMinimized){
debug.trace("Update Screen MIN");
updatemincaption();
}
}


/*Update Song Info*/
function updatesonginfo(){
try{
name2set=iTunesApp.CurrentTrack.Name;
artist2set=iTunesApp.CurrentTrack.Artist;
album2set=iTunesApp.CurrentTrack.Album;

//album art if different from previous
if(titledisplay.innerText!=name2set || artistdisplay.innerText!=iTunesApp.CurrentTrack.Artist || albulmdisplay.innerText!=album2set){
saveart();
}

titledisplay.innerText=name2set;
artistdisplay.innerText=artist2set;
albulmdisplay.innerText=album2set;
eval("otherdisp.innerText=iTunesApp.CurrentTrack."+options.getValue("OP_OTHER_INFO_OPT"));
}
catch(error){
titledisplay.innerText="Nothing ";
artistdisplay.innerText="Playing";
albulmdisplay.innerText="---";
otherdisp.innerText="---";
artworkdisplay.src="icon_large.png";
largeartworkdisplay.src="icon_superduperlarge.png";
}
}

/*Update Power Indicator*/
function updatepower(){
powerbardisplay.value=framework.system.power.percentRemaining;

if(framework.system.power.charging==true){
chargeicondisplay.visible=true;
pluggedicondisplay.visible=false;
}
else if(framework.system.power.pluggedIn==true){
//plugged in (or if plugged and charge complete)
chargeicondisplay.visible=false;
pluggedicondisplay.visible=true;
}
else{
pluggedicondisplay.visible=false;
chargeicondisplay.visible=false;
}

}

/*Update track progress*/
function updatetrackprogress(){
try{
var totaltracktime;
//alert(iTunesApp.CurrentTrack.Time);
//totaltracktime=iTunesApp.CurrentTrack.Time.split(":");
//debug.trace(totaltracktime[0]+":"+totaltracktime[1]);
//totaltracktime=parseInt(totaltracktime[0])*60+parseInt(totaltracktime[1]);
totaltracktime=iTunesApp.CurrentTrack.Duration;
trackprogressdisplay.value=iTunesApp.PlayerPosition/totaltracktime*100;
//track displ text
trackpositiondisplay.innerText=time(iTunesApp.PlayerPosition*1000);
trackleftdisplay.innerText="-";
//debug.trace(totaltracktime-iTunesApp.PlayerPosition);
trackleftdisplay.innerText+=time((totaltracktime-iTunesApp.PlayerPosition)*1000);
}
catch(error){
trackprogressdisplay.value=0;
trackpositiondisplay.innerText="0:00";
trackleftdisplay.innerText="-0:00";
}
}

/*Update track select pos progress*/
function updatetrackselectposprogress(){
try{
trackdiamonddisplay.x=((iTunesApp.PlayerPosition/iTunesApp.CurrentTrack.Duration)*106);
//track displ text
tracksetpositiondisplay.innerText=time(iTunesApp.PlayerPosition*1000);
tracksetleftdisplay.innerText="-";
tracksetleftdisplay.innerText+=time((iTunesApp.CurrentTrack.Duration-iTunesApp.PlayerPosition)*1000);
}
catch(error){
trackdiamonddisplay.x=0;
tracksetpositiondisplay.innerText="0:00";
tracksetleftdisplay.innerText="-0:00";
}
}

/*Update volume progress*/
function updatevolumeprogress(){
try{
volumeprogressdisplay.value=iTunesApp.SoundVolume;
}
catch(error){
volumeprogressdisplay.value=0;
}
}


/*Update track progress*/
function updatestars(){
try{
iTunesApp.CurrentTrack.Rating
//if 100 5 stars
if (iTunesApp.CurrentTrack.Rating==100){
star1display.visible=true;
star2display.visible=true;
star3display.visible=true;
star4display.visible=true;
star5display.visible=true;
}
//if 80 4 stars
else if (iTunesApp.CurrentTrack.Rating>79){
star1display.visible=true;
star2display.visible=true;
star3display.visible=true;
star4display.visible=true;
star5display.visible=false;
}
//if 60 3 stars
else if (iTunesApp.CurrentTrack.Rating>59){
star1display.visible=true;
star2display.visible=true;
star3display.visible=true;
star4display.visible=false;
star5display.visible=false;
}
//if 40 2 stars
else if (iTunesApp.CurrentTrack.Rating>39){
star1display.visible=true;
star2display.visible=true;
star3display.visible=false;
star4display.visible=false;
star5display.visible=false;
}
//if 20 1 stars
else if (iTunesApp.CurrentTrack.Rating>19){
star1display.visible=true;
star2display.visible=false;
star3display.visible=false;
star4display.visible=false;
star5display.visible=false;
}
//if 0 0 stars
else if (iTunesApp.CurrentTrack.Rating>=0){
star1display.visible=false;
star2display.visible=false;
star3display.visible=false;
star4display.visible=false;
star5display.visible=false;
}
}
catch(error){
star1display.visible=false;
star2display.visible=false;
star3display.visible=false;
star4display.visible=false;
star5display.visible=false;
}
}

/*Update Play/Pause*/
//PlayerState -play/pause?
function updateplay_pause(){
try{
if(iTunesApp.PlayerState==0){
play_pausedisp.src="images\\pausehead.png";
}
if(iTunesApp.PlayerState==1){
play_pausedisp.src="images\\playhead.png";
}
}
catch(error){
play_pausedisp.src="images\\pausehead.png";
}
}
/*Second to Min converter*/
//realy its in mili but so what?

function two(x) {return ((x>9)?"":"0")+x}
function three(x) {return ((x>99)?"":"0")+((x>9)?"":"0")+x}

function time(ms) {
var sec = Math.floor(ms/1000)
ms = ms % 1000
//t = three(ms)

var min = Math.floor(sec/60)
sec = sec % 60
t = two(sec)
// + ":" + t

var hr = Math.floor(min/60)
min = min % 60
t = two(min) + ":" + t

var day = Math.floor(hr/60)
hr = hr % 60
t = two(hr) + ":" + t
//t = day + ":" + t

tsplitvar=t.split(":");
if(tsplitvar[0]=="00"){
return tsplitvar[1]+":"+tsplitvar[2];
}
else{
return t;
}

}


/*Save Artwork to File*/
function saveart(){
try{
var ArtFormat=iTunesApp.CurrentTrack.Artwork.Item(1).Format;
if(ArtFormat==1){
iTunesApp.CurrentTrack.Artwork.Item(1).SaveArtworkToFile("C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.jpeg");
artworkdisplay.src="C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.jpeg";
largeartworkdisplay.src="C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.jpeg";
/* add artowrk again 
titledisplay.x=114;
artistdisplay.x=114;
albulmdisplay.x=114;
titledisplay.width=72;
artistdisplay.width=72;
albulmdisplay.width=72;*/
}
else if(ArtFormat==2){
iTunesApp.CurrentTrack.Artwork.Item(1).SaveArtworkToFile("C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.png");
artworkdisplay.src="C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.png";
largeartworkdisplay.src="C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.png";
/* add artowrk again 
titledisplay.x=114;
artistdisplay.x=114;
albulmdisplay.x=114;
titledisplay.width=72;
artistdisplay.width=72;
albulmdisplay.width=72;*/

}
else if(ArtFormat==3){
iTunesApp.CurrentTrack.Artwork.Item(1).SaveArtworkToFile("C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.bmp");
artworkdisplay.src="C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.bmp";
largeartworkdisplay.src="C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.bmp";
/* add artowrk again 
titledisplay.x=114;
artistdisplay.x=114;
albulmdisplay.x=114;
titledisplay.width=72;
artistdisplay.width=72;
albulmdisplay.width=72;*/
}
else{
artworkdisplay.src="icon_large.png";
largeartworkdisplay.src="icon_superduperlarge.png";
/*Remove Artwork make text full
titledisplay.x=80;
artistdisplay.x=80;
albulmdisplay.x=80;
titledisplay.width=100;
artistdisplay.width=100;
albulmdisplay.width=100;*/
}
}
catch(error){
artworkdisplay.src="icon_large.png";
largeartworkdisplay.src="icon_superduperlarge.png";
}
}

/*Shuffle vol*/
function shufflevol(valuetomove){
try{
if (valuetomove=="-1"){
if(iTunesApp.SoundVolume!=0){
iTunesApp.SoundVolume=iTunesApp.SoundVolume-10;
updatevolumeprogress();
}
}
else if (valuetomove=="+1"){
if(iTunesApp.SoundVolume!=100){
iTunesApp.SoundVolume=iTunesApp.SoundVolume+10;
updatevolumeprogress();
}
}
}
catch(error){
//nothing realys
}
}

/*Show on open Help*/
function showonopenhelp(){
//alert(ON_OPEN_POP_HELP);
if(helpdivison && !iTunesIsOn){
if(options.getValue("OP_SHOW_ON_OPEN_HELP_OPT")){
helpdiv.visible=true;
helpdivnano3G.visible=true;
helpdivnano.visible=true;
}
else{
helpdiv.visible=false;
helpdivnano3G.visible=false;
helpdivnano.visible=false;
}
}
}

/*Hide help*/
function hidehelpdiv(){
helpdiv.visible=false;
helpdivnano3G.visible=false;
helpdivnano.visible=false;
helpdivison=false;
}
