﻿//================================================
/*

 gPod Controller - Control your iTunes with your gPod.
 Copyright (c) 2007 Glenn Rivkees.
 http://glennrivkees.com/gadgets/

    This file is part of gPod Controller.

    gPod Controller is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    gPod Controller is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with gPod Controller; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    To view a copy of this license, visit http://creativecommons.org/licenses/GPL/2.0/

*/
//================================================
var texttomarquee3G;

/*Update Song Info*/
function updatesonginfo3G(){
try{
name2set=iTunesApp.CurrentTrack.Name;
artist2set=iTunesApp.CurrentTrack.Artist;
album2set=iTunesApp.CurrentTrack.Album;

//album art if different from previous and set int if different
if(texttomarquee3G!=name2set || artistdisplay3G.innerText!=iTunesApp.CurrentTrack.Artist || albulmdisplay3G.innerText!=album2set){
debug.trace("Info Diffrent: marq:"+texttomarquee3G+" nametoset:"+name2set);
saveart3G();
	titledisplay3G.innerText=" "+name2set;
	texttomarquee3G=name2set
	//clearInterval(marqueeint);
	//var marqueeint = setInterval("marquee(titledisplay3G,name2set,'     ')", 750) 
}
if(titledisplay3G.innerText.length<texttomarquee3G.length) titledisplay3G.innerText+="         "+texttomarquee3G; //append loop
titledisplay3G.innerText=titledisplay3G.innerText.substring (1); //remove first character of label

//titledisplay3G.innerText=name2set;
artistdisplay3G.innerText=artist2set;
albulmdisplay3G.innerText=album2set;
eval("otherdisp3G.innerText=iTunesApp.CurrentTrack."+options.getValue("OP_OTHER_INFO_OPT"));
}
catch(error){
titledisplay3G.innerText="Nothing ";
	//clearInterval(marqueeint);
artistdisplay3G.innerText="Playing";
albulmdisplay3G.innerText="---";
otherdisp3G.innerText="---";
artworkdisplay3G.src="icon_superduperlarge.png";
largeartworkdisplay3G.src="icon_superduperlarge.png";
}
}

/*Update Power Indicator*/
function updatepower3G(){
powerbardisplay3G.value=framework.system.power.percentRemaining;

if(framework.system.power.charging==true){
chargeicondisplay3G.visible=true;
pluggedicondisplay3G.visible=false;
}
else if(framework.system.power.pluggedIn==true){
//plugged in (or if plugged and charge complete)
chargeicondisplay3G.visible=false;
pluggedicondisplay3G.visible=true;
}
else{
pluggedicondisplay3G.visible=false;
chargeicondisplay3G.visible=false;
}

}

/*Update track progress*/
function updatetrackprogress3G(){
try{
var totaltracktime;
//alert(iTunesApp.CurrentTrack.Time);
//totaltracktime=iTunesApp.CurrentTrack.Time.split(":");
//debug.trace(totaltracktime[0]+":"+totaltracktime[1]);
//totaltracktime=parseInt(totaltracktime[0])*60+parseInt(totaltracktime[1]);
totaltracktime=iTunesApp.CurrentTrack.Duration;
trackprogressdisplay3G.value=iTunesApp.PlayerPosition/totaltracktime*100;
//track displ text
trackpositiondisplay3G.innerText=time(iTunesApp.PlayerPosition*1000);
trackleftdisplay3G.innerText="-";
//debug.trace(totaltracktime-iTunesApp.PlayerPosition);
trackleftdisplay3G.innerText+=time((totaltracktime-iTunesApp.PlayerPosition)*1000);
}
catch(error){
trackprogressdisplay3G.value=0;
trackpositiondisplay3G.innerText="0:00";
trackleftdisplay3G.innerText="-0:00";
}
}

/*Update track select pos progress*/
function updatetrackselectposprogress3G(){
try{
trackdiamonddisplay3G.x=((iTunesApp.PlayerPosition/iTunesApp.CurrentTrack.Duration)*106)+6;
//track displ text
tracksetpositiondisplay3G.innerText=time(iTunesApp.PlayerPosition*1000);
tracksetleftdisplay3G.innerText="-";
tracksetleftdisplay3G.innerText+=time((iTunesApp.CurrentTrack.Duration-iTunesApp.PlayerPosition)*1000);
}
catch(error){
trackdiamonddisplay3G.x=6;
tracksetpositiondisplay3G.innerText="0:00";
tracksetleftdisplay3G.innerText="-0:00";
}
}

/*Update volume progress*/
function updatevolumeprogress3G(){
try{
volumeprogressdisplay3G.value=iTunesApp.SoundVolume;
}
catch(error){
volumeprogressdisplay3G.value=0;
}
}


/*Update track progress*/
function updatestars3G(){
try{
iTunesApp.CurrentTrack.Rating
//if 100 5 stars
if (iTunesApp.CurrentTrack.Rating==100){
star1display3G.visible=true;
star2display3G.visible=true;
star3display3G.visible=true;
star4display3G.visible=true;
star5display3G.visible=true;
graystar1display3G.visible=true;
graystar2display3G.visible=true;
graystar3display3G.visible=true;
graystar4display3G.visible=true;
graystar5display3G.visible=true;

}
//if 80 4 stars
else if (iTunesApp.CurrentTrack.Rating>79){
star1display3G.visible=true;
star2display3G.visible=true;
star3display3G.visible=true;
star4display3G.visible=true;
star5display3G.visible=false;
graystar1display3G.visible=true;
graystar2display3G.visible=true;
graystar3display3G.visible=true;
graystar4display3G.visible=true;
graystar5display3G.visible=false;
}
//if 60 3 stars
else if (iTunesApp.CurrentTrack.Rating>59){
star1display3G.visible=true;
star2display3G.visible=true;
star3display3G.visible=true;
star4display3G.visible=false;
star5display3G.visible=false;
graystar1display3G.visible=true;
graystar2display3G.visible=true;
graystar3display3G.visible=true;
graystar4display3G.visible=false;
graystar5display3G.visible=false;
}
//if 40 2 stars
else if (iTunesApp.CurrentTrack.Rating>39){
star1display3G.visible=true;
star2display3G.visible=true;
star3display3G.visible=false;
star4display3G.visible=false;
star5display3G.visible=false;
graystar1display3G.visible=true;
graystar2display3G.visible=true;
graystar3display3G.visible=false
graystar4display3G.visible=false;
graystar5display3G.visible=false;
}
//if 20 1 stars
else if (iTunesApp.CurrentTrack.Rating>19){
star1display3G.visible=true;
star2display3G.visible=false;
star3display3G.visible=false;
star4display3G.visible=false;
star5display3G.visible=false;
graystar1display3G.visible=true;
graystar2display3G.visible=false;
graystar3display3G.visible=false
graystar4display3G.visible=false;
graystar5display3G.visible=false;
}
//if 0 0 stars
else if (iTunesApp.CurrentTrack.Rating>=0){
star1display3G.visible=false;
star2display3G.visible=false;
star3display3G.visible=false;
star4display3G.visible=false;
star5display3G.visible=false;
graystar1display3G.visible=false;
graystar2display3G.visible=false;
graystar3display3G.visible=false
graystar4display3G.visible=false;
graystar5display3G.visible=false;
}
}
catch(error){
star1display3G.visible=false;
star2display3G.visible=false;
star3display3G.visible=false;
star4display3G.visible=false;
star5display3G.visible=false;
graystar1display3G.visible=false;
graystar2display3G.visible=false;
graystar3display3G.visible=false
graystar4display3G.visible=false;
graystar5display3G.visible=false;
}
}

/*Update Play/Pause*/
//PlayerState -play/pause?
function updateplay_pause3G(){
try{
if(iTunesApp.PlayerState==0){
play_pausedisp3G.src="imagesnano3G\\pausehead.png";
}
if(iTunesApp.PlayerState==1){
play_pausedisp3G.src="imagesnano3G\\playhead.png";
}
}
catch(error){
play_pausedisp3G.src="imagesnano3G\\pausehead.png";
}
}

/*Save Artwork to File*/
function saveart3G(){
try{
var ArtFormat=iTunesApp.CurrentTrack.Artwork.Item(1).Format;
if(ArtFormat==1){
iTunesApp.CurrentTrack.Artwork.Item(1).SaveArtworkToFile("C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.jpeg");
artworkdisplay3G.src="C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.jpeg";
largeartworkdisplay3G.src="C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.jpeg";
/* add artowrk again 
titledisplay.x=114;
artistdisplay.x=114;
albulmdisplay.x=114;
titledisplay.width=72;
artistdisplay.width=72;
albulmdisplay.width=72;*/
}
else if(ArtFormat==2){
iTunesApp.CurrentTrack.Artwork.Item(1).SaveArtworkToFile("C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.png");
artworkdisplay3G.src="C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.png";
largeartworkdisplay3G.src="C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.png";
/* add artowrk again 
titledisplay.x=114;
artistdisplay.x=114;
albulmdisplay.x=114;
titledisplay.width=72;
artistdisplay.width=72;
albulmdisplay.width=72;*/

}
else if(ArtFormat==3){
iTunesApp.CurrentTrack.Artwork.Item(1).SaveArtworkToFile("C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.bmp");
artworkdisplay3G.src="C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.bmp";
largeartworkdisplay3G.src="C:\\WINDOWS\\Temp\\~gPodController_ArtworkTemp.bmp";
/* add artowrk again 
titledisplay.x=114;
artistdisplay.x=114;
albulmdisplay.x=114;
titledisplay.width=72;
artistdisplay.width=72;
albulmdisplay.width=72;*/
}
else{
artworkdisplay3G.src="icon_superduperlarge.png";
largeartworkdisplay3G.src="icon_superduperlarge.png";
/*Remove Artwork make text full
titledisplay.x=80;
artistdisplay.x=80;
albulmdisplay.x=80;
titledisplay.width=100;
artistdisplay.width=100;
albulmdisplay.width=100;*/
}
}
catch(error){
artworkdisplay3G.src="icon_superduperlarge.png";
largeartworkdisplay3G.src="icon_superduperlarge.png";
}
}


/*Help Scroll NANO 3G*/
function sbOnChangenano3G(){
	sbnano3G.max=374-helpdivnano3G.height+10
	if (sbnano3G.max<0)
	sbnano3G.max=0;
	helplblnano3G.y=-sbnano3G.value+5;
helpbut1nano3G.y=360-sbnano3G.value+5;
}

//////////////////////
//------------------//
/*Select for Nano 3G*/
//------------------//
//////////////////////

var displaymode3G=0;

function selectbuttonpress3G(){
debug.trace("select for nano 3G pressed");
if (iTunesIsOn==1){
displaymode3G++;
//if rollover back to 1
if (displaymode3G==5){
displaymode3G=1;
}

//set display mode screen
if (displaymode3G==1){
debug.trace("disp mode1");
displaydiv13G.visible=true;
displaydiv23G.visible=false;
displaydiv33G.visible=false;
displaydiv43G.visible=false;
hide_volume3G();
}
else if (displaymode3G==2){
displaydiv13G.visible=false;
displaydiv23G.visible=true;
displaydiv33G.visible=false;
displaydiv43G.visible=false;
hide_volume3G();
}
else if (displaymode3G==3){
displaydiv13G.visible=false;
displaydiv23G.visible=false;
displaydiv33G.visible=true;
displaydiv43G.visible=false;
hide_volume3G();
}
else if (displaymode3G==4){
displaydiv13G.visible=false;
displaydiv23G.visible=false;
displaydiv33G.visible=false;
displaydiv43G.visible=true;
hide_volume3G();
}

}
}


/*Display Modes*/
//1=track progress view(volume set)
//2=track progress set
//3=artwork view
//4=stars




//////////////////////
//------------------//
/*Scroll for Nano 3G*/
//------------------//
//////////////////////

var last_seg_num;

function scrollcheck3G(segment_number){
segment_number=parseInt(segment_number);
if (segment_number==last_seg_num-1){
//down
//updownbox.innerText="down"+last_seg_num+"->"+segment_number;
scrollmoved3G("-1");
last_seg_num=segment_number;
}
else if(segment_number==last_seg_num+1){
//up
//updownbox.innerText="up"+last_seg_num+"->"+segment_number;
scrollmoved3G("+1");
last_seg_num=segment_number;
}
else if(segment_number=="1"&&last_seg_num=="24"){
//up
//updownbox.innerText="up"+last_seg_num+"-r>"+segment_number;
scrollmoved3G("+1");
last_seg_num=segment_number;
}
else if(segment_number=="24"&&last_seg_num=="1"){
//up
//updownbox.innerText="down"+last_seg_num+"-r>"+segment_number;
scrollmoved3G("-1");
last_seg_num=segment_number;
}
else{
//updownbox.innerText="set"+segment_number;
last_seg_num=segment_number;
}

}

/*Scrolled Moved. Fires after the above*/
function scrollmoved3G(valuetomove){
//TRY
try{
//TRY
if (displaymode3G==1){
//volume

	if(options.getValue("OP_VOL_OPT")){
		if(displayvolumediv3G.visible==false){
			clearTimeout(volume_timeout3G);
			volume_timeout3G = setTimeout("hide_volume3G()",2000);
		}

		var volume_timeout3G;

		updatevolumeprogress3G();

		displayvolumediv3G.visible=true;
		if (valuetomove=="-1"){
			if(iTunesApp.SoundVolume!=0){
				iTunesApp.SoundVolume=iTunesApp.SoundVolume-3;
				updatevolumeprogress3G();
			}
		}
		else if (valuetomove=="+1"){
			if(iTunesApp.SoundVolume!=100){
				iTunesApp.SoundVolume=iTunesApp.SoundVolume+3;
				updatevolumeprogress3G();
			}
		}
	}
}
else if (displaymode3G==2){
//track location
//1 click=4 sec
//iTunesApp.PlayerPosition
//Diamond
if (valuetomove=="-1"){
if(iTunesApp.PlayerPosition<4){
iTunesApp.PlayerPosition=0;
updatetrackselectposprogress3G()
}
else if(iTunesApp.PlayerPosition!=0){
iTunesApp.PlayerPosition=iTunesApp.PlayerPosition-4;
updatetrackselectposprogress3G()
}
}
else if (valuetomove=="+1"){
if(iTunesApp.PlayerPosition!=iTunesApp.CurrentTrack.Duration){
iTunesApp.PlayerPosition=iTunesApp.PlayerPosition+4;
updatetrackselectposprogress3G()
}
}

}
else if (displaymode3G==3){
//naught
}
//stars
else if (displaymode3G==4){
if (valuetomove=="-1"){
if(iTunesApp.CurrentTrack.Rating!=0){
iTunesApp.CurrentTrack.Rating=iTunesApp.CurrentTrack.Rating-20;
updatestars3G();
}
}
else if (displaymode=="+1"){
if(iTunesApp.CurrentTrack.Rating!=100){
iTunesApp.CurrentTrack.Rating=iTunesApp.CurrentTrack.Rating+20;
updatestars3G();
}
}
}
//END TRY
}
//END TRY
//CATCH
catch(error){
//alert(error)
volumeprogressdisplay3G.value=0;
}
//CATCH
}



var holdon3G=0;
/*Hold Stuff*/
function holdpress3G(){
if (holdon3G==0){
holdbut3G.x=45;
holdcover3G.visible=true;
lockdisp3G.visible=true;
holdon3G=1;
}
else if (holdon3G==1){
holdbut3G.x=35;
holdcover3G.visible=false;
lockdisp3G.visible=false;
holdon3G=0;
}
}

/*Hold Key Press*/
function checkkey(e){
var characterCode //literal character code will be stored in this variable

if(e && e.which){ //if which property of event object is supported (NN4)
e = e
characterCode = e.which //character code is contained in NN4's which property
}
else{
e = event
characterCode = e.keyCode //character code is contained in IE's keyCode property
}

if(characterCode == 104){ //if generated character code is equal to ascii 104 (if h key)
holdpress();
}
}

/*hide Volume*/
function hide_volume3G(){
debug.trace("hidevol3G");
displayvolumediv3G.visible=false;
}



/*Help Scroll*/
function sbOnChange3G(){
	//list.height=NUMBER_OF_ITEMS*list.itemHeight;
//22 lines
//	sb.max=NUMBER_OF_ITEMS*list.itemHeight-listDiv.height;
	sbshuff3G.max=340-helpdiv.height+10
//27*14-helpdiv.height+10;
	if (sbshuff3G.max<0)
	sbshuff3G.max=0;
	helplbl3G.y=-sbshuff.value+5;
helpbut13G.y=327-sbshuff.value+5;
//helpbut2.y=370-sb.value+5;
}