﻿//================================================
/*

 gPod Controller - Control your iTunes with your gPod.
 Copyright (c) 2007 Glenn Rivkees.
 http://glennrivkees.com/gadgets/

    This file is part of gPod Controller.

    gPod Controller is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    gPod Controller is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with gPod Controller; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    To view a copy of this license, visit http://creativecommons.org/licenses/GPL/2.0/

*/
//================================================


//---
//add menu item
//---
function onAddCustomMenuItems(menu) {
  // Add each item. Note that this needs to be done each time this function is
  // called.
  menu.AddItem("Check for Update", 0, checkupdatea);
  menu.AddItem("Button Descriptions", 0, openbuttondescript);
function checkupdatea(){checkupdate("frommenu")}
//open button descriptions
function openbuttondescript(){
	var winShell = new ActiveXObject("Shell.Application");
	winShell.ShellExecute("http://www.glennrivkees.com/grplugins/gpod-gadget/#descriptions");
}
}

//---
//Update Check
//---
function checkupdate(is_menu){
//check for an update
//load the xml
var updatexmlDoc = new ActiveXObject("Microsoft.XMLDOM");
function updateloadXML(uxmlFile)
{
 updatexmlDoc.async="false";
 updatexmlDoc.onreadystatechange=verify;
 updatexmlDoc.load(uxmlFile);
 updatexmlObj=updatexmlDoc.documentElement;
}

function verify()
{
 // 0 Object is not initialized
 // 1 Loading object is loading data
 // 2 Loaded object has loaded data
 // 3 Data from object can be worked with
 // 4 Object completely initialized
 if (updatexmlDoc.readyState != 4)
 {
   return false;
 }
}
try{
updateloadXML('http://glennrivkees.com/plugins/gpod/latestversion.xml');
//set version number vars
latestVis=updatexmlObj.childNodes(0).childNodes(1).text
versionis = GADGET_VERSION_NUM;
//set changes var
changesinver1 = updatexmlObj.childNodes(0).childNodes(2).childNodes(0).text
changesinver2 = updatexmlObj.childNodes(0).childNodes(2).childNodes(1).text
downloadurl = updatexmlObj.childNodes(0).childNodes(2).childNodes(2).text
//alert(updatexmlObj.childNodes(0).childNodes(1).text)
if(versionis!=latestVis){
alert("A newer version of the \"gPod Controller\" gadget is availible.\nIt is recomended that you update. \n\nYou currently have version "+versionis+" and the latest version is "+latestVis+".\n\n"+changesinver1+"\n"+changesinver2)
wanttodownload = confirm('Do you wish to go to the gadget download website?');
	if(wanttodownload==true){
	var winShell = new ActiveXObject("Shell.Application");
	winShell.ShellExecute(downloadurl); 
	}
}
else if(is_menu=="frommenu"){alert("You have the latest version.\n\nYou currently have version "+versionis+" and the latest version is "+latestVis+".")}
}
catch (e){
if(is_menu=="frommenu"){alert("Error checking for updates. Please check your network connection.")}
}
}