﻿//================================================
/*

 gPod Controller - Control your iTunes with your gPod.
 Copyright (c) 2007 Glenn Rivkees.
 http://glennrivkees.com/gadgets/

    This file is part of gPod Controller.

    gPod Controller is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    gPod Controller is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with gPod Controller; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    To view a copy of this license, visit http://creativecommons.org/licenses/GPL/2.0/

*/
//================================================


function onOpen() {
  // Set the checkmarks in the dialog to the current settings
 opclbcombo.selectedIndex=options.getValue('OP_COL_OPT')-1;
 opclbcombo3G.selectedIndex=options.getValue('OP_COL_OPT_3G')-1;
 opclbcomboSHUFF.selectedIndex=options.getValue('OP_COL_OPT_SHUFF')-1;

//Undocked select
if(options.getValue('OP_SHOW_UNDOCKED_OPT')==2) opundcombo.selectedIndex=2;
if(options.getValue('OP_SHOW_UNDOCKED_OPT')==3) opundcombo.selectedIndex=0;
if(options.getValue('OP_SHOW_UNDOCKED_OPT')==1) opundcombo.selectedIndex=1;

//docked select
if(options.getValue('OP_SHOW_DOCKED_OPT')==2) opdoccombo.selectedIndex=0;
if(options.getValue('OP_SHOW_DOCKED_OPT')==3) opdoccombo.selectedIndex=1;
if(options.getValue('OP_SHOW_DOCKED_OPT')==1) opdoccombo.selectedIndex=2;


 OP_OFF_BOX.value = options.getValue("OP_OFF_OPT");

 OP_VOL_BOX.value = options.getValue("OP_VOL_OPT");

 OP_SHOW_HELP_BOX.value = options.getValue("OP_SHOW_ON_OPEN_HELP_OPT");

 OP_OTHER_INFO_BOX.value = options.getValue("OP_OTHER_INFO_OPT");
/* N/A   eval("oplb"+options.getValue('OP_VOL_OPT')+".selected=true")*/
}

function onCancel() {
  // No settings will be saved.
}

function onOk() {


//OP_OFF
options.putValue("OP_OFF_OPT", OP_OFF_BOX.value); 

//OP_VOL
options.putValue("OP_VOL_OPT", OP_VOL_BOX.value); 

//showhelp op
options.putValue("OP_SHOW_ON_OPEN_HELP_OPT", OP_SHOW_HELP_BOX.value); 

/*N/A
//OP_VOL
if(oplb1.selected==true){
options.putValue("OP_VOL_OPT", 1); 
}
else if(oplb2.selected==true){
options.putValue("OP_VOL_OPT", 2); 
}
*/

//OP_OTHER
options.putValue("OP_OTHER_INFO_OPT", OP_OTHER_INFO_BOX.value); 

/*N/A
//SCROLL_WHEN
*/


//color
//NANO 2G
options.putValue("OP_COL_OPT", opclbcombo.selectedIndex+1);
//NANO 3G
options.putValue("OP_COL_OPT_3G", opclbcombo3G.selectedIndex+1);
//Shuffle
options.putValue("OP_COL_OPT_SHUFF", opclbcomboSHUFF.selectedIndex+1);

//docked
if(opdoclb1.selected==true){
options.putValue("OP_SHOW_DOCKED_OPT", 1); 
}
else if(opdoclb2.selected==true){
options.putValue("OP_SHOW_DOCKED_OPT", 2); 
}
else if(opdoclb3.selected==true){
options.putValue("OP_SHOW_DOCKED_OPT", 3); 
}



//undocked
if(opundlb1.selected==true){
options.putValue("OP_SHOW_UNDOCKED_OPT", 1); 
}
else if(opundlb2.selected==true){
options.putValue("OP_SHOW_UNDOCKED_OPT", 2); 
}
else if(opundlb3.selected==true){
options.putValue("OP_SHOW_UNDOCKED_OPT", 3); 
}

debug.trace('ok');

}

function alertotherinfo(){
alert("Choices of information to be shown: \nMust be typed in exactly! \n\nBitRate \nBPM \nComment \nCompilation \nComposer \nDateAdded \nDiscCount \nDiscNumber \nDuration \nEnabled \nEQ \nGenre \nKindAsString \nModificationDate \nPlayedCount \nPlayedDate \nSampleRate \nSize \nTime \nTrackCount \nTrackNumber \nYear");
}