﻿//================================================
/*

 gPod Controller - Control your iTunes with your gPod.
 Copyright (c) 2007 Glenn Rivkees.
 http://glennrivkees.com/gadgets/

    This file is part of gPod Controller.

    gPod Controller is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    gPod Controller is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with gPod Controller; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    To view a copy of this license, visit http://creativecommons.org/licenses/GPL/2.0/

*/
//================================================


//
//
/*OPTIONS RELATED CODE*/
//
//

function onOptionChanged() {
//stuff to do
//updateall

  // Find out the new display mode
  if (isDocked) {
    debug.trace('ok is docked');
		//show shuffle
		if(options.getValue("OP_SHOW_DOCKED_OPT")==2){
			change2shuffle();
		}
		//show nano 2G
		else if(options.getValue("OP_SHOW_DOCKED_OPT")==1){
			change2nano2G();
		}
		//show nano 3G
		else if(options.getValue("OP_SHOW_DOCKED_OPT")==3){
			change2nano3G();
		}
  } else if (!isDocked) {
    debug.trace('ok is undocked');
		//show nano 2G
		if(options.getValue("OP_SHOW_UNDOCKED_OPT")==1){
			change2nano2G();
		}
		//show shuffle
		else if(options.getValue("OP_SHOW_UNDOCKED_OPT")==2){
			change2shuffle();
		}
		//show nano 3G
		else if(options.getValue("OP_SHOW_UNDOCKED_OPT")==3){
			change2nano3G();
		}
  }

//update screen
updatescreen();
//change bg color
changebgcolor();
//show/hide help
showonopenhelp();
}

/*function onOpenOptionsClick() {
  // Show the options dialog. This is one of many ways a user can be shown
  // this dialog. Another method is for them to right click on the gadget and
  // to select the "Options" menu item.
  pluginHelper.showOptionsDialog();
}*/


/*Change BG color*/
function changebgcolor(){
bggpodimage.src="ipodbgs\\ipodbg"+options.getValue('OP_COL_OPT')+".png";
bggpodimage3G.src="ipodbgs\\nano3Gbg"+options.getValue('OP_COL_OPT_3G')+".png";
bgshuffleimage.src="ipodbgs\\shufflebg"+options.getValue('OP_COL_OPT_SHUFF')+".png";
}


/*on open set the bg and state and such*/
function onopensetbg(){
onOptionChanged();
}