﻿//================================================
/*

 gPod Controller - Control your iTunes with your gPod.
 Copyright (c) 2007 Glenn Rivkees.
 http://glennrivkees.com/gadgets/

    This file is part of gPod Controller.

    gPod Controller is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    gPod Controller is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with gPod Controller; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    To view a copy of this license, visit http://creativecommons.org/licenses/GPL/2.0/

*/
//================================================


var last_seg_num;

function scrollcheck(segment_number){
segment_number=parseInt(segment_number);
if (segment_number==last_seg_num-1){
//down
//updownbox.innerText="down"+last_seg_num+"->"+segment_number;
scrollmoved("-1");
last_seg_num=segment_number;
}
else if(segment_number==last_seg_num+1){
//up
//updownbox.innerText="up"+last_seg_num+"->"+segment_number;
scrollmoved("+1");
last_seg_num=segment_number;
}
else if(segment_number=="1"&&last_seg_num=="24"){
//up
//updownbox.innerText="up"+last_seg_num+"-r>"+segment_number;
scrollmoved("+1");
last_seg_num=segment_number;
}
else if(segment_number=="24"&&last_seg_num=="1"){
//up
//updownbox.innerText="down"+last_seg_num+"-r>"+segment_number;
scrollmoved("-1");
last_seg_num=segment_number;
}
else{
//updownbox.innerText="set"+segment_number;
last_seg_num=segment_number;
}

}

/*Scrolled Moved. Fires after the above*/
function scrollmoved(valuetomove){
//TRY
try{
//TRY
if (displaymode==1){
//volume
	//IF VOLUME ADJUSTMENT IS ENABLED
	if(options.getValue("OP_VOL_OPT")){

		if(displayvolumediv.visible==false){
			clearTimeout(volume_timeout);
			volume_timeout = setTimeout("hide_volume()",2000);
		}

		var volume_timeout;

		updatevolumeprogress();

		displayvolumediv.visible=true;
		if (valuetomove=="-1"){
			if(iTunesApp.SoundVolume!=0){
				iTunesApp.SoundVolume=iTunesApp.SoundVolume-3;
				updatevolumeprogress();
			}
		}
		else if (valuetomove=="+1"){
			if(iTunesApp.SoundVolume!=100){
				iTunesApp.SoundVolume=iTunesApp.SoundVolume+3;
				updatevolumeprogress();
			}
		}
	}
}
else if (displaymode==2){
//track location
//1 click=4 sec
//iTunesApp.PlayerPosition
//Diamond
if (valuetomove=="-1"){
if(iTunesApp.PlayerPosition<4){
iTunesApp.PlayerPosition=0;
updatetrackselectposprogress()
}
else if(iTunesApp.PlayerPosition!=0){
iTunesApp.PlayerPosition=iTunesApp.PlayerPosition-4;
updatetrackselectposprogress()
}
}
else if (valuetomove=="+1"){
if(iTunesApp.PlayerPosition!=iTunesApp.CurrentTrack.Duration){
iTunesApp.PlayerPosition=iTunesApp.PlayerPosition+4;
updatetrackselectposprogress()
}
}

}
else if (displaymode==3){
//naught
}
//stars
else if (displaymode==4){
if (valuetomove=="-1"){
if(iTunesApp.CurrentTrack.Rating!=0){
iTunesApp.CurrentTrack.Rating=iTunesApp.CurrentTrack.Rating-20;
updatestars();
}
}
else if (valuetomove=="+1"){
if(iTunesApp.CurrentTrack.Rating!=100){
iTunesApp.CurrentTrack.Rating=iTunesApp.CurrentTrack.Rating+20;
updatestars();
}
}
}
//END TRY
}
//END TRY
//CATCH
catch(error){
//alert(error)
volumeprogressdisplay.value=0;
}
//CATCH
}



var holdon=0;
/*Hold Stuff*/
function holdpress(){
if (holdon==0){
holdbut.x=70;
holdcover.visible=true;
lockdisp.visible=true;
holdon=1;
}
else if (holdon==1){
holdbut.x=60;
holdcover.visible=false;
lockdisp.visible=false;
holdon=0;
}
}

/*Hold Key Press*/
function checkkey(e){
var characterCode //literal character code will be stored in this variable

if(e && e.which){ //if which property of event object is supported (NN4)
e = e
characterCode = e.which //character code is contained in NN4's which property
}
else{
e = event
characterCode = e.keyCode //character code is contained in IE's keyCode property
}

if(characterCode == 104){ //if generated character code is equal to ascii 104 (if h key)
holdpress();
}
}

/*hide Volume*/
function hide_volume(){
displayvolumediv.visible=false;
}



/*Help Scroll*/
function sbOnChange(){
	//list.height=NUMBER_OF_ITEMS*list.itemHeight;
//22 lines
//	sb.max=NUMBER_OF_ITEMS*list.itemHeight-listDiv.height;
	sbshuff.max=364-helpdiv.height+10
//27*14-helpdiv.height+10;
	if (sbshuff.max<0)
	sbshuff.max=0;
	helplbl.y=-sbshuff.value+5;
helpbut1.y=347-sbshuff.value+5;
//helpbut2.y=370-sb.value+5;
}

/*Help Scroll NANO*/
function sbOnChangenano(){
	sbnano.max=403-helpdivnano.height+10
	if (sbnano.max<0)
	sbnano.max=0;
	helplblnano.y=-sbnano.value+5;
helpbut1nano.y=388-sbnano.value+5;
}