﻿//================================================
/*

 gPod Controller - Control your iTunes with your gPod.
 Copyright (c) 2007 Glenn Rivkees.
 http://glennrivkees.com/gadgets/

    This file is part of gPod Controller.

    gPod Controller is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    gPod Controller is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with gPod Controller; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    To view a copy of this license, visit http://creativecommons.org/licenses/GPL/2.0/

*/
//================================================

var isDocked;
var isMinimized;
var UI2show;

/*CHANGE UI's*/
function change2nano2G(){
UI2show=1;
updatescreen();
gpodnano.visible="true";
gpodnano3G.visible="false";
gpodshuffle.visible="false";
view.resizeTo(300, 373);
}
function change2nano3G(){
UI2show=3;
updatescreen();
gpodnano.visible="false";
gpodnano3G.visible="true";
gpodshuffle.visible="false";
view.resizeTo(185, 240);
}
function change2shuffle(){
UI2show=2;
gpodnano.visible="false";
gpodnano3G.visible="false";
gpodshuffle.visible="true";
view.resizeTo(130, 100);
}


// Called when gadget is first opened.
function onOpenStateStuff(){
  // ...
onDisplayTargetChange(gddTargetSidebar);
  // Assume the gadget is docked at first.
  // The onDisplayTargetChange handler will be notified if it is in fact
  // undocked.
  isDocked = true;

  // Handle notifications sent when gadget is docked or undocked.
  pluginHelper.onDisplayTargetChange = onDisplayTargetChange;
//view.ondock="debug.trace('Display target changed to docked');";
//view.onundock="debug.trace('Display target changed to undocked');";

/*view.onpopin=onPopIn;
view.onpopout=onPopOut;*/

  // Handle notifications sent when gadget is minimized. 
  view.onminimize = onMinimize;
  // Handle notifications sent when gadget is restored (maximized)
  view.onrestore = onRestore; 

  // ...
}

function onDisplayTargetChange(displayTarget) {
  // Find out the new display mode
  if (displayTarget == gddTargetSidebar) {
    debug.trace('Display target changed to docked');
    isDocked = true;


//show shuffle
if(options.getValue("OP_SHOW_DOCKED_OPT")==2){
change2shuffle();
}
//show nano
else if(options.getValue("OP_SHOW_DOCKED_OPT")==1){
change2nano2G();
}
//show nano 3G
else if(options.getValue("OP_SHOW_DOCKED_OPT")==3){
	change2nano3G();
}



  } else if (displayTarget == gddTargetFloatingView) {
    debug.trace('Display target changed to undocked');
    isDocked = false;


//show nano
if(options.getValue("OP_SHOW_UNDOCKED_OPT")==1){
debug.trace('undocked show nano');
change2nano2G();
}
//show shuffle
else if(options.getValue("OP_SHOW_UNDOCKED_OPT")==2){
debug.trace('undocked show shuffle');
change2shuffle();
}
//show nano 3G
else if(options.getValue("OP_SHOW_UNDOCKED_OPT")==3){
	change2nano3G();
}



  }
}


function onMinimize() {
  debug.trace('Minimized');
  isMinimized = true;
}

function onRestore() {
  debug.trace('Restored');
  isMinimized = false;
view.caption = strings.GADGET_NAME;

  // Find out the new display mode
  if (isDocked) {
    debug.trace('restore is docked');
  //  isDocked = true;
//show shuffle
if(options.getValue("OP_SHOW_DOCKED_OPT")==2){
change2shuffle();
}
//show nano
else if(options.getValue("OP_SHOW_DOCKED_OPT")==1){
change2nano2G();
}
//show nano 3G
else if(options.getValue("OP_SHOW_DOCKED_OPT")==3){
	change2nano3G();
}

  } else if (!isDocked) {
    debug.trace('restore is undocked');
  //  isDocked = false;
//show nano
if(options.getValue("OP_SHOW_UNDOCKED_OPT")==1){
change2nano2G();
}
//show shuffle
else if(options.getValue("OP_SHOW_UNDOCKED_OPT")==2){
change2shuffle();
}
//show nano 3G
else if(options.getValue("OP_SHOW_UNDOCKED_OPT")==3){
	change2nano3G();
}
  }



//  refresh();
}

function updatemincaption(){
if(iTunesIsOn){
try{
view.caption = "gPod: " + iTunesApp.CurrentTrack.Name + " - " + iTunesApp.CurrentTrack.Artist + " - " + iTunesApp.CurrentTrack.Album;
}
catch(error){
view.caption = "gPod: -Nothing Playing-"
}
}
}



/*ON OFF FOR SHUFFLE*/
function shuffleonoffpress(){
if (iTunesIsOn==0){
debug.trace("itunes to on");
shuffleonoffbut.x=95;
iTunesOnOff();
}
else if (iTunesIsOn==1){
debug.trace("itunes to off");
shuffleonoffbut.x=85;
iTunesOnOff();
}
}